﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace PayPool.Demo.Common
{
    public class AESHelper
    {
        /// <summary>
        /// Aes加密算法
        /// </summary>
        /// <param name="encryptString">要加密的字符串</param>
        /// <param name="sKey">加密码Key</param>
        /// <returns>正确返回加密后的结果，错误返回源字符串</returns>
        public static string ToAESEncrypt(string encryptString, string sKey, string iv)
        {

            //sKey = EncodeBase64(sKey);
            byte[] keyBytes = Encoding.UTF8.GetBytes(sKey);
            byte[] keyIV = Encoding.UTF8.GetBytes(iv);
            byte[] inputByteArray = Encoding.UTF8.GetBytes(encryptString);

            AesCryptoServiceProvider aesProvideres = new AesCryptoServiceProvider();
            //DESCryptoServiceProvider desProvider = new DESCryptoServiceProvider();

            // java 默认的是ECB模式，PKCS5padding；c#默认的CBC模式，PKCS7padding 所以这里我们默认使用CBC方式
            aesProvideres.Mode = CipherMode.CBC;
            MemoryStream memStream = new MemoryStream();
            CryptoStream crypStream = new CryptoStream(memStream, aesProvideres.CreateEncryptor(keyBytes, keyIV), CryptoStreamMode.Write);

            crypStream.Write(inputByteArray, 0, inputByteArray.Length);
            crypStream.FlushFinalBlock();
            return Convert.ToBase64String(memStream.ToArray());
        }

        /// <summary>
        /// Aes解密算法
        /// </summary>
        /// <param name="decryptString">要解密的字符串</param>
        /// <param name="sKey">加密Key</param>
        /// <returns>正确返回加密后的结果，错误返回源字符串</returns>
        public static string ToAESDecrypt(string decryptString, string sKey, string iv)
        {
            //sKey = EncodeBase64(sKey);
            byte[] keyBytes = Encoding.UTF8.GetBytes(sKey);
            byte[] keyIV = Encoding.UTF8.GetBytes(iv);
            byte[] inputByteArray = Convert.FromBase64String(decryptString);

            AesCryptoServiceProvider aesProvideres = new AesCryptoServiceProvider();
            //DESCryptoServiceProvider desProvider = new DESCryptoServiceProvider();

            // java 默认的是ECB模式，PKCS5padding；c#默认的CBC模式，PKCS7padding 所以这里我们默认使用ECB方式
            aesProvideres.Mode = CipherMode.CBC;
            MemoryStream memStream = new MemoryStream();
            CryptoStream crypStream = new CryptoStream(memStream, aesProvideres.CreateDecryptor(keyBytes, keyIV), CryptoStreamMode.Write);

            crypStream.Write(inputByteArray, 0, inputByteArray.Length);
            crypStream.FlushFinalBlock();
            return Encoding.Default.GetString(memStream.ToArray());

        }


    }
}
