﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Text;

namespace PayPool.Demo.Common
{
    public class SignValidate
    {
        public static string Sign(SortedDictionary<string, string> dic,  string key) {
            string sign = MD5(JsonConvert.SerializeObject(dic).ToLower() + key);
            return sign;
        }


        #region 工具
        /// <summary>
        /// MD5散列
        /// </summary>
        public static string MD5(string inputStr)
        {
            MD5 md5 = new MD5CryptoServiceProvider();
            byte[] hashByte = md5.ComputeHash(Encoding.UTF8.GetBytes(inputStr));
            StringBuilder sb = new StringBuilder();
            foreach (byte item in hashByte)
                sb.Append(item.ToString("x").PadLeft(2, '0'));
            return sb.ToString();
        }
        
        /// <summary>
        /// 将字符串转为base64
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public static string ToBase64String(string str)
        {
            return Convert.ToBase64String(Encoding.GetEncoding("UTF-8").GetBytes(str));
        }

        /// <summary>
        /// 序列化拼接URL
        /// </summary>
        /// <param name="dic">参数集合</param>
        /// <returns></returns>
        public static string ToUrl(IDictionary<string, string> dic)
        {
            string buff = "";
            foreach (KeyValuePair<string, string> pair in dic)
            {
                if (pair.Value != null && pair.Value.ToString() != "")
                {
                    buff += pair.Key + "=" + pair.Value + "&";
                }
            }
            buff = buff.Trim('&');
            return buff;
        }
        #endregion
    }
}