﻿using System;
using System.IO;
using System.IO.Compression;
using System.Net;
using System.Text;

namespace PayPool.Demo.Common
{
    public class WebHelper
    {
        /// <summary>
        /// 以get方式发送请求
        /// </summary>
        /// <param name="url"></param>
        /// <returns></returns>
        public static String DoGet(String url)
        {
            String html = "";
            StreamReader reader = null;
            HttpWebRequest webReqst = (HttpWebRequest)WebRequest.Create(url);
            webReqst.Method = "GET";
            webReqst.UserAgent = "Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.15 Safari/537.36";
            webReqst.KeepAlive = true;
            //webReqst.Timeout = 30000;
            //webReqst.ReadWriteTimeout = 30000;
            try
            {
                HttpWebResponse webResponse = (HttpWebResponse)webReqst.GetResponse();
                if (webResponse.StatusCode == HttpStatusCode.OK && webResponse.ContentLength < 1024 * 1024)
                {
                    Stream stream = webResponse.GetResponseStream();
                    stream.ReadTimeout = 30000;
                    if (webResponse.ContentEncoding == "gzip")
                    {
                        reader = new StreamReader(new GZipStream(stream, CompressionMode.Decompress), Encoding.UTF8);
                    }
                    else
                    {
                        reader = new StreamReader(stream, Encoding.UTF8);
                    }
                    html = reader.ReadToEnd();
                }
            }
            catch (Exception e)
            {
                html = e.ToString();
            }

            return html;
        }

        /// <summary>
        /// 以post方式发送数据
        /// </summary>
        /// <param name="url"></param>
        /// <param name="dic"></param>
        /// <returns></returns>
        public static string DoPostJson(string url, string json, string sign)
        {
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(url);

            Encoding encoding = Encoding.UTF8;

            byte[] bs = Encoding.UTF8.GetBytes(json);
            string responseData = String.Empty;
            req.Method = "POST";
            req.ContentType = "application/json; charset=utf-8;";
            req.ContentLength = bs.Length;
            req.Headers.Add("Authorization", "sign " + sign);
            using (Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(bs, 0, bs.Length);
                reqStream.Close();
            }
            using (HttpWebResponse response = (HttpWebResponse)req.GetResponse())
            {
                using (StreamReader reader = new StreamReader(response.GetResponseStream(), encoding))
                {
                    responseData = reader.ReadToEnd().ToString();
                }
            }
            return responseData;
        }
    }
}