﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace PayPool.Demo.Controllers
{
    public class DemoController : Controller
    {
        private static string agentappid = "0752498a702d497f9313bcf921383935";                       // 代理商appid
        private static string agentkey = "9c90f3cdc8a34a4d9cedcf423ecdcb1c";                         // 代理商密钥
        private static string mchappid = "189e98e3cd0c44558b08dfcff7d9e9bb";                         // 商户appid
        private static string mchkey = "97096799c614493497f4f41a3409d186";                           // 商户密钥

        // GET: Demo
        public ActionResult Index()
        {
            return View();
        }

        /// <summary>
        /// 进件
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult MerchantCreate()
        {
            RequestModels.CreateMerchantParam mchPararm = new RequestModels.CreateMerchantParam();
            mchPararm.VendorAppId = agentappid;
            mchPararm.MchName = "测试商户";
            mchPararm.Province = 10;
            mchPararm.City = 110;
            mchPararm.BankAccountType = Enums.BankAccountType.借记卡;
            mchPararm.BankName = "中国建设银行";
            mchPararm.BankCard = "6227001252450145361";
            mchPararm.BankHolder = "尚爱专";
            mchPararm.ContactPhone = "13776772220";
            mchPararm.IdentityCard = "320323198402040630";
            mchPararm.IdentityBackImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.IdentityFrontImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.BusinessLicenseNum = "0000000000";
            mchPararm.BusinessLicenseImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.BankCardImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.BrandImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.IndoorImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.OutdoorImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.Rate = (decimal)0.004;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("VendorAppId", mchPararm.VendorAppId);                                       // 必填
            dic.Add("MchName", mchPararm.MchName);                                               // 必填
            dic.Add("Province", mchPararm.Province.ToString());                                  // 必填
            dic.Add("City", mchPararm.City.ToString());                                          // 必填
            dic.Add("BankAccountType", ((int)mchPararm.BankAccountType).ToString());             // 必填 
            dic.Add("BankName", mchPararm.BankName);                                             // 必填
            dic.Add("BankCard", mchPararm.BankCard);                                             // 必填
            dic.Add("BankHolder", mchPararm.BankHolder);                                         // 必填
            dic.Add("ContactPhone", mchPararm.ContactPhone);                                     // 必填
            dic.Add("IdentityCard", mchPararm.IdentityCard);                                     // 必填
            dic.Add("IdentityBackImg", mchPararm.IdentityBackImg);                               // 必填
            dic.Add("IdentityFrontImg", mchPararm.IdentityFrontImg);                             // 必填
            dic.Add("BusinessLicenseNum", mchPararm.BusinessLicenseNum);                         // 必填
            dic.Add("BusinessLicenseImg", mchPararm.BusinessLicenseImg);                         // 必填
            dic.Add("BankCardImg", mchPararm.BankCardImg);                                       // 必填
            dic.Add("BrandImg", mchPararm.BrandImg);                                             // 必填
            dic.Add("IndoorImg", mchPararm.IndoorImg);                                           // 必填
            dic.Add("OutdoorImg", mchPararm.OutdoorImg);                                         // 必填
            dic.Add("Rate", mchPararm.Rate.ToString());                                          // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("http://api.juyouke.cc/api/Merchant/Create", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 修改进件信息
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult MerchantEdit()
        {
            RequestModels.EditMerchantParam mchPararm = new RequestModels.EditMerchantParam();
            mchPararm.AppId = mchappid;
            mchPararm.VendorAppId = agentappid;
            mchPararm.MchName = "测试商户2";
            mchPararm.Province = 10;
            mchPararm.City = 110;
            mchPararm.BankAccountType = Enums.BankAccountType.借记卡;
            mchPararm.BankName = "中国建设银行";
            mchPararm.BankCard = "6227001252450145361";
            mchPararm.BankHolder = "尚爱专";
            mchPararm.ContactPhone = "13776772220";
            mchPararm.IdentityCard = "320323198402040630";
            mchPararm.IdentityBackImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.IdentityFrontImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.BusinessLicenseNum = "0000000000";
            mchPararm.BusinessLicenseImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.BankCardImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.BrandImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.IndoorImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.OutdoorImg = "http://payadmin.myxz.cc/Content/admin/images/logo2.jpg";
            mchPararm.Rate = (decimal)0.004;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("AppId", mchPararm.AppId);                                                   // 必填
            dic.Add("VendorAppId", mchPararm.VendorAppId);                                       // 必填
            dic.Add("MchName", mchPararm.MchName);                                               // 必填
            dic.Add("Province", mchPararm.Province.ToString());                                  // 必填
            dic.Add("City", mchPararm.City.ToString());                                          // 必填
            dic.Add("BankAccountType", ((int)mchPararm.BankAccountType).ToString());             // 必填 
            dic.Add("BankName", mchPararm.BankName);                                             // 必填
            dic.Add("BankCard", mchPararm.BankCard);                                             // 必填
            dic.Add("BankHolder", mchPararm.BankHolder);                                         // 必填
            dic.Add("ContactPhone", mchPararm.ContactPhone);                                     // 必填
            dic.Add("IdentityCard", mchPararm.IdentityCard);                                     // 必填
            dic.Add("IdentityBackImg", mchPararm.IdentityBackImg);                               // 必填
            dic.Add("IdentityFrontImg", mchPararm.IdentityFrontImg);                             // 必填
            dic.Add("BusinessLicenseNum", mchPararm.BusinessLicenseNum);                         // 必填
            dic.Add("BusinessLicenseImg", mchPararm.BusinessLicenseImg);                         // 必填
            dic.Add("BankCardImg", mchPararm.BankCardImg);                                       // 必填
            dic.Add("BrandImg", mchPararm.BrandImg);                                             // 必填
            dic.Add("IndoorImg", mchPararm.IndoorImg);                                           // 必填
            dic.Add("OutdoorImg", mchPararm.OutdoorImg);                                         // 必填
            dic.Add("Rate", mchPararm.Rate.ToString());                                          // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("http://api.juyouke.cc/api/Merchant/Edit", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 修改商户费率
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult MerchantEditRate()
        {
            RequestModels.EditRateParam mchPararm = new RequestModels.EditRateParam();
            mchPararm.AppId = mchappid;
            mchPararm.VendorAppId = agentappid;
            mchPararm.Rate = (decimal)0.007;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("AppId", mchPararm.AppId);                                                   // 必填
            dic.Add("VendorAppId", mchPararm.VendorAppId);                                       // 必填
            dic.Add("Rate", mchPararm.Rate.ToString());                                          // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("http://api.juyouke.cc/api/Merchant/EditRate", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 获取商户密钥
        /// </summary>
        /// <returns></returns>
        public ActionResult GetAppKey()
        {
            RequestModels.GetAppKeyParam mchPararm = new RequestModels.GetAppKeyParam();
            mchPararm.app_id = mchappid;
            mchPararm.VendorAppId = agentappid;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", mchPararm.app_id);                                                 // 必填
            dic.Add("VendorAppId", mchPararm.VendorAppId);                                       // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("http://api.juyouke.cc/api/Merchant/getappkey", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }
        public ActionResult TestUnAes(string str,string iv)
        {
            var result = Common.AESHelper.ToAESDecrypt(HttpUtility.UrlEncode(str), agentkey, iv);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }


        /// <summary>
        /// 扫码支付
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult CodePay(string authcode)
        {
            RequestModels.CodeParam payPararm = new RequestModels.CodeParam();
            payPararm.app_id = mchappid;
            payPararm.auth_code = authcode;
            payPararm.notify_url = "http://agentapi.mychengshi.com/test/index";
            payPararm.operator_id = "Pay";
            payPararm.out_trade_no = DateTime.Now.ToString("yyyyMMddHHmmss") + Common.StringHelper.SequenceId(); ;
            payPararm.payway = 3;
            payPararm.subject = "测试下单商品";
            payPararm.total_amount = 1;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", payPararm.app_id);              // 必填
            dic.Add("auth_code", payPararm.auth_code);        // 必填
            dic.Add("notify_url", payPararm.notify_url);      // 必填
            dic.Add("operator_id", payPararm.operator_id);
            dic.Add("out_trade_no", payPararm.out_trade_no);  // 必填
            dic.Add("payway", payPararm.payway.ToString());
            dic.Add("subject", payPararm.subject);            // 必填
            dic.Add("total_amount", payPararm.total_amount.ToString());      // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/codepay/", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 小程序支付
        /// </summary>
        /// <returns></returns>
        public ActionResult MiniPay()
        {
            RequestModels.MiniParam payPararm = new RequestModels.MiniParam();
            payPararm.app_id = mchappid;
            payPararm.notify_url = "http://pooladmin.juyouke.cc/test/Notify_Url";
            payPararm.operator_id = "Pay";
            payPararm.out_trade_no = DateTime.Now.ToString("yyyyMMddHHmmss") + Common.StringHelper.SequenceId(); ;
            payPararm.payway = 3;
            payPararm.subject = "测试下单商品";
            payPararm.total_amount = 1;
            payPararm.mini_appid = "134678592599269265";
            payPararm.openid = "134678592599269265";

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", payPararm.app_id);              // 必填
            dic.Add("notify_url", payPararm.notify_url);      // 必填
            dic.Add("operator_id", payPararm.operator_id);
            dic.Add("out_trade_no", payPararm.out_trade_no);  // 必填
            dic.Add("payway", payPararm.payway.ToString());
            dic.Add("subject", payPararm.subject);            // 必填
            dic.Add("total_amount", payPararm.total_amount.ToString());      // 必填
            dic.Add("mini_appid", payPararm.mini_appid);      // 必填
            dic.Add("openid", payPararm.openid);              // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            var result = Common.WebHelper.DoPostJson("http://api.juyouke.cc/api/mini/", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// H5页面支付
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public void H5Pay()
        {
            RequestModels.WapParam payPararm = new RequestModels.WapParam();
            payPararm.app_id = mchappid;
            payPararm.notify_url = "http://agentapi.mychengshi.com/test/index";
            payPararm.operator_id = "1";
            payPararm.out_trade_no = DateTime.Now.ToString("yyyyMMddHHmmss") + Common.StringHelper.SequenceId(); ;
            payPararm.payway = 3;
            payPararm.subject = "TEST";
            payPararm.total_amount = 1;
            payPararm.return_url = "https://www.baidu.com";

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", payPararm.app_id);              // 必填
            dic.Add("notify_url", payPararm.notify_url);      // 必填
            dic.Add("operator_id", payPararm.operator_id);    // 必填
            dic.Add("out_trade_no", payPararm.out_trade_no);  // 必填
            dic.Add("payway", payPararm.payway.ToString());
            dic.Add("subject", payPararm.subject);            // 必填
            dic.Add("total_amount", payPararm.total_amount.ToString());      // 必填
            dic.Add("return_url", payPararm.return_url);      // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            dic.Add("sign", sign);      // 必填
            dic["notify_url"] = HttpUtility.UrlEncode(payPararm.notify_url);
            dic["subject"] = HttpUtility.UrlEncode(payPararm.subject);
            dic["return_url"] = HttpUtility.UrlEncode(payPararm.return_url);

            var paramJson = Common.SignValidate.ToUrl(dic);

            Common.WebHelper.DoGet("https://api.juyouke.cc/getway?" + paramJson);

            //return Json( "https://192.168.111.1:12345/getway?" +  paramJson,JsonRequestBehavior.AllowGet);
        }
               
        /// <summary>
        /// H5页面支付
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult H5AliPay()
        {
            RequestModels.WapParam payPararm = new RequestModels.WapParam();
            payPararm.app_id = mchappid;
            payPararm.notify_url = "http://agentapi.mychengshi.com/test/index";
            payPararm.operator_id = "1";
            payPararm.out_trade_no = DateTime.Now.ToString("yyyyMMddHHmmss") + Common.StringHelper.SequenceId(); ;
            payPararm.payway = 3;
            payPararm.subject = "TEST";
            payPararm.total_amount = 1;
            payPararm.return_url = "https://www.baidu.com";

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", payPararm.app_id);              // 必填
            dic.Add("notify_url", payPararm.notify_url);      // 必填
            dic.Add("operator_id", payPararm.operator_id);    // 必填
            dic.Add("out_trade_no", payPararm.out_trade_no);  // 必填
            dic.Add("payway", payPararm.payway.ToString());
            dic.Add("subject", payPararm.subject);            // 必填
            dic.Add("total_amount", payPararm.total_amount.ToString());      // 必填
            dic.Add("return_url", payPararm.return_url);      // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            dic.Add("sign", sign);      // 必填
            dic["notify_url"] = HttpUtility.UrlEncode(payPararm.notify_url);
            dic["subject"] = HttpUtility.UrlEncode(payPararm.subject);
            dic["return_url"] = HttpUtility.UrlEncode(payPararm.return_url);

            var paramJson = Common.SignValidate.ToUrl(dic);

            var result = Common.WebHelper.DoGet("https://api.juyouke.cc/getway/app?" + paramJson);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 查询订单
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult QueryPay()
        {
            RequestModels.QueryPayParam pararm = new RequestModels.QueryPayParam();
            pararm.app_id = mchappid;
            pararm.out_trade_no = "20181008180415000003"; 
            pararm.trade_no = "00003420181008180441";

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", pararm.app_id);                    // 必填
            dic.Add("out_trade_no", pararm.out_trade_no);        // 二填一
            dic.Add("trade_no", pararm.trade_no);                // 二填一

            var sign = Common.SignValidate.Sign(dic, mchkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/query/", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 提现
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult Settle()
        {
            RequestModels.SettleParam pararm = new RequestModels.SettleParam();
            pararm.app_id = mchappid;
            pararm.total_amount = 202;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", pararm.app_id);                            // 必填
            dic.Add("total_amount", pararm.total_amount.ToString());     // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/settle/", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 提现查询
        /// </summary>
        /// <returns></returns>
        public ActionResult SettleQuery(string trade_no)
        {
            RequestModels.SettleQueryParam pararm = new RequestModels.SettleQueryParam();
            pararm.app_id = mchappid;
            pararm.trade_no = trade_no;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", pararm.app_id);                            // 必填
            dic.Add("trade_no", pararm.trade_no);                        // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/settlequery/", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 服务商提现
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult AgentSettle()
        {
            RequestModels.AgentWithdrawParam pararm = new RequestModels.AgentWithdrawParam();
            pararm.VendorAppId = agentappid;
            pararm.Amount = 500 * 100;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("VendorAppId", pararm.VendorAppId);               // 必填
            dic.Add("Amount", pararm.Amount.ToString());              // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/Merchant/agent_withdraw", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 服务商提现查询
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult AgentSettleQuery(string trade_no)
        {
            RequestModels.AgentWithQueryParam pararm = new RequestModels.AgentWithQueryParam();
            pararm.VendorAppId = agentappid;
            pararm.trade_no = trade_no;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("VendorAppId", pararm.VendorAppId);                            // 必填
            dic.Add("trade_no", pararm.trade_no);                        // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/Merchant/withdraw_query", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 余额查询
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult BalanceQuery()
        {
            RequestModels.AppIdParam pararm = new RequestModels.AppIdParam();
            pararm.app_id = mchappid;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("app_id", pararm.app_id);              // 必填

            var sign = Common.SignValidate.Sign(dic, mchkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/balance_query/", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }

        /// <summary>
        /// 服务商余额查询
        /// 测试OK
        /// </summary>
        /// <returns></returns>
        public ActionResult AgentBalanceQuery()
        {
            RequestModels.VendorAppIdParam pararm = new RequestModels.VendorAppIdParam();
            pararm.VendorAppId = agentappid;

            SortedDictionary<string, string> dic = new SortedDictionary<string, string>();
            dic.Add("VendorAppId", pararm.VendorAppId);              // 必填

            var sign = Common.SignValidate.Sign(dic, agentkey);

            var result = Common.WebHelper.DoPostJson("https://api.juyouke.cc/api/Merchant/agentbalance", JsonConvert.SerializeObject(dic), sign);

            return Json(new { result }, JsonRequestBehavior.AllowGet);
        }


    }
}