﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace PayPool.Demo.RequestModels
{
    /// <summary>
    /// 商户入网接口（创建商户的）业务模型
    /// </summary>
    [Serializable]
    public class CreateMerchantParam
    {
        /// <summary>
        /// VendorAppId
        /// </summary>
        public string VendorAppId { get; set; }
        /// <summary>
        /// 商户名称
        /// </summary>
        public string MchName { get; set; }
        /// <summary>
        /// 商户所在省份序号
        /// </summary>
        public int Province { get; set; }
        /// <summary>
        /// 商户所在城市序号
        /// </summary>
        public int City { get; set; }
        /// <summary>
        /// 银行卡类型 借记卡 = 0,贷记卡 = 1,
        /// </summary>
        public Enums.BankAccountType BankAccountType { get; set; }
        /// <summary>
        /// 银行名称
        /// </summary>
        public string BankName { get; set; }
        /// <summary>
        /// 银行卡号
        /// </summary>
        public string BankCard { get; set; }
        /// <summary>
        /// 持卡人
        /// </summary>
        public string BankHolder { get; set; }
        /// <summary>
        /// 持卡人手机号
        /// </summary>
        public string ContactPhone { get; set; }
        /// <summary>
        /// 持卡人身份证号
        /// </summary>
        public string IdentityCard { get; set; }
        /// <summary>
        /// 身份证反面照片
        /// </summary>
        public string IdentityBackImg { get; set; }
        /// <summary>
        /// 身份证正面照片
        /// </summary>
        public string IdentityFrontImg { get; set; }
        /// <summary>
        /// 营业执照号(工商注册号)
        /// </summary>
        public string BusinessLicenseNum { get; set; }
        /// <summary>
        /// 营业执照图片
        /// </summary>
        public string BusinessLicenseImg { get; set; }
        /// <summary>
        /// 银行卡正面图片
        /// </summary>
        public string BankCardImg { get; set; }
        /// <summary>
        /// 门头照片
        /// </summary>
        public string BrandImg { get; set; }
        /// <summary>
        /// 室内照片
        /// </summary>
        public string IndoorImg { get; set; }
        /// <summary>
        /// 室外照片
        /// </summary>
        public string OutdoorImg { get; set; }

        /// <summary>
        /// 费率
        /// </summary>
        public decimal Rate { get; set; }
    }
}